import random
import re
import services
import clock
import date_and_time
import services
import buffs.buff
import sims.sim
import interactions.base.mixer_interaction
import interactions.base.super_interaction
import interactions.utils.statistic_element
import objects.components.consumable_component
import sims4.commands
import sims4.resources
from sims4.resources import Types
import MATY
from MATY import log, inject_to, error, get_tuning_name, tuning_in_list, GetResource

from MATY import subscribe_load_data_into_class, subscribe_post_tuning_load, tuning_in_list
def patch_all_defs(*args, **kwargs):
    patch_defs(services.get_instance_manager(Types.BROADCASTER))
    return
subscribe_post_tuning_load(patch_all_defs)

puddles = [ '^broadcaster_(\w+)Puddle_Slip' ]

from event_testing.tests import CompoundTestList
from interactions import ParticipantType
from sims.sim_info_tests import BuffTest
def patch_defs(self, *args, **kwargs):
    if self is None: return
    try:
        if self.TYPE == Types.BROADCASTER:
            ghost = GetResource(Types.SNIPPET, 101703) # testSet_ActorIsNotGhost
            hover = [
                GetResource(Types.BUFF, 223735), # buff_Humanoid_Robots_HoverMode_WalkStyle
                GetResource(Types.BUFF, 226744), # buff_MechanicalSuit_HoverMode
            ]
            while None in hover: hover.remove(None)
            hovertest = None
            if ghost is None: return
            for cls in self._tuned_classes.values():
                if tuning_in_list(cls, puddles):
                    fixme = False
                    if cls.allow_sim_test:
                        for i in range(len(cls.allow_sim_test)):
                            if ghost not in cls.allow_sim_test[i]:
                                fixme = True
                                break
                            pass
                    if fixme or not cls.allow_sim_test:
                        nu = CompoundTestList(list(cls.allow_sim_test) if cls.allow_sim_test else [])
                        for i in range(len(nu)):
                            if ghost not in nu[i]:
                                nu[i] += (ghost,)
                                if hover and hovertest is None:
                                    hovertest = BuffTest(
                                        apply_whitelist_on_individual_basis=True,
                                        blacklist=frozenset(hover),
                                        blacklist_tags=None,
                                        subject=ParticipantType.Actor,
                                        tooltip=None,
                                        whitelist=None,
                                        whitelist_tags=None
                                    )
                                if hovertest is not None: nu[i] += (hovertest,)
                            pass
                        pass
                        cls.allow_sim_test = nu
                    pass
                pass
            pass
        pass
    except BaseException as e:
        error('Failed patching {}'.format(self.TYPE), e, log)
    return    
